Open CASCADE Technology: Select3D_SensitiveEntity Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Member Functions
Select3D_SensitiveEntity Class Referenceabstract

Abstract framework to define 3D sensitive entities. As the selection process uses the principle of a projection of 3D shapes onto a 2D view where nearness to a rectangle determines whether a shape is picked or not, all 3D shapes need to be converted into 2D ones in order to be selected. More...

`#include <Select3D_SensitiveEntity.hxx>`

Inheritance diagram for Select3D_SensitiveEntity:
[legend]

## Public Member Functions
Standard_Boolean | NeedsConversion () const
| Returns true if this framework needs conversion. More...
Standard_Boolean | Is3D () const
| Returns true if this framework provides 3D information. More...
virtual void | Project (const Handle< Select3D_Projector > &aProjector)=0
| In classes inheriting this framework, you must redefine this function in order to get a sensitive 2D rectangle from a 3D entity. This rectangle is the sensitive zone which makes the 3D entity selectable. More...
virtual Standard_Integer | MaxBoxes () const
| Returns the max number of sensitive areas returned by this class is 1 by default. Else on must redefine this method. More...
virtual Handle < Select3D_SensitiveEntity > | GetConnected (const TopLoc_Location &aLocation)
| Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity. More...
virtual Standard_Boolean | Matches (const Standard_Real XMin, const Standard_Real YMin, const Standard_Real XMax, const Standard_Real YMax, const Standard_Real aTol)
| Matches the box defined by the coordinates Xmin, Ymin, Xmax, Ymax with the entity found at that point within the tolerance aTol. Xmin, YMin define the minimum point in the lower left hand corner of the box, and XMax, YMax define the maximum point in the upper right hand corner of the box. You must redefine this function for every inheriting entity. You will have to call this framework inside the redefined function. More...
virtual Standard_Boolean | Matches (const TColgp_Array1OfPnt2d &Polyline, const Bnd_Box2d &aBox, const Standard_Real aTol)
| prevents from hiding virtual methods... More...
virtual Standard_Boolean | HasLocation () const
| Returns true if this framework has a location defined. More...
virtual const TopLoc_Location | Location () const
virtual void | ResetLocation ()
| sets the location to Identity More...
virtual void | SetLocation (const TopLoc_Location &aLoc)
virtual void | Dump (Standard_OStream &S, const Standard_Boolean FullDump=Standard_True) const
| 2 options : <FullDump> = False -> general information <FullDump> = True -> whole informtion 3D +2d ... More...
void | UpdateLocation (const TopLoc_Location &aLoc)
Public Member Functions inherited from SelectBasics_SensitiveEntity
virtual void | Set (const Handle< SelectBasics_EntityOwner > &TheOwnerId)
const Handle < SelectBasics_EntityOwner > & | OwnerId () const
virtual void | Areas (SelectBasics_ListOfBox2d &aresult)=0
| to be implemented specifically by each type of sensitive primitive . More...
virtual Standard_Boolean | Matches (const SelectBasics_PickArgs &thePickArgs, Standard_Real &theMatchDMin, Standard_Real &theMatchDepth)=0
| Checks whether the sensitive entity matches the picking detection area (close to the picking line). This method takes into account depth limits produced by abstract view: far/near planes, clippings. Please port existing implementations of your picking detection, which were done at Matches (X, Y, Tol, DMin) method to this one, introducing the depth checks. Please note that the previous method is suppressed and the virtual implementations are not used by OCC selection framework. The porting procedure for simple sensitives (or if you are not interested in implementing full scale depth checks) can be simplified to writing the following code snippet: More...
void | SetSensitivityFactor (const Standard_ShortReal aFactor)
Standard_ShortReal | SensitivityFactor () const
| allows a better sensitivity for a specific entity in selection algorithms useful for small sized entities. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Static Public Member Functions
static void | DumpBox (Standard_OStream &S, const Bnd_Box2d &abox)

## Protected Member Functions
| Select3D_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &OwnerId)
Protected Member Functions inherited from SelectBasics_SensitiveEntity
| SelectBasics_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &OwnerId, const Standard_ShortReal aSensitivityFactor=1)

## Additional Inherited Members
Protected Attributes inherited from SelectBasics_SensitiveEntity
Handle< SelectBasics_EntityOwner > | myOwnerId

## Detailed Description

Abstract framework to define 3D sensitive entities. As the selection process uses the principle of a projection of 3D shapes onto a 2D view where nearness to a rectangle determines whether a shape is picked or not, all 3D shapes need to be converted into 2D ones in order to be selected.

## Constructor & Destructor Documentation

Select3D_SensitiveEntity::Select3D_SensitiveEntity | ( | const Handle< SelectBasics_EntityOwner > & | OwnerId | ) |
| protected

## Member Function Documentation

virtual void Select3D_SensitiveEntity::Dump | ( | Standard_OStream & | S,
|  | const Standard_Boolean | FullDump = `Standard_True`
| ) |  | const
| virtual

2 options : <FullDump> = False -> general information <FullDump> = True -> whole informtion 3D +2d ...

Reimplemented in Select3D_SensitiveTriangulation, Select3D_SensitiveSegment, Select3D_SensitiveCircle, Select3D_SensitiveWire, Select3D_SensitiveCurve, Select3D_SensitiveTriangle, Select3D_SensitiveBox, Select3D_SensitiveFace, and Select3D_SensitivePoint.

static void Select3D_SensitiveEntity::DumpBox | ( | Standard_OStream & | S,
|  | const Bnd_Box2d & | abox
| ) |  |
| static

virtual Handle< Select3D_SensitiveEntity > Select3D_SensitiveEntity::GetConnected | ( | const TopLoc_Location & | aLocation | ) |
| virtual

Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity.

Reimplemented in Select3D_SensitiveCircle, Select3D_SensitiveGroup, Select3D_SensitiveSegment, Select3D_SensitiveCurve, Select3D_SensitiveTriangle, Select3D_SensitiveFace, Select3D_SensitiveTriangulation, Select3D_SensitiveBox, Select3D_SensitiveWire, Select3D_SensitivePoint, MeshVS_SensitivePolyhedron, and MeshVS_SensitiveMesh.

virtual Standard_Boolean Select3D_SensitiveEntity::HasLocation | ( |  | ) | const
| virtual

Returns true if this framework has a location defined.

Standard_Boolean Select3D_SensitiveEntity::Is3D | ( |  | ) | const
| virtual

Returns true if this framework provides 3D information.

Implements SelectBasics_SensitiveEntity.

virtual const TopLoc_Location Select3D_SensitiveEntity::Location | ( |  | ) | const
| virtual

virtual Standard_Boolean Select3D_SensitiveEntity::Matches | ( | const Standard_Real | XMin,
|  | const Standard_Real | YMin,
|  | const Standard_Real | XMax,
|  | const Standard_Real | YMax,
|  | const Standard_Real | aTol
| ) |  |
| virtual

Matches the box defined by the coordinates Xmin, Ymin, Xmax, Ymax with the entity found at that point within the tolerance aTol. Xmin, YMin define the minimum point in the lower left hand corner of the box, and XMax, YMax define the maximum point in the upper right hand corner of the box. You must redefine this function for every inheriting entity. You will have to call this framework inside the redefined function.

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveGroup, Select3D_SensitiveSegment, Select3D_SensitiveCircle, Select3D_SensitiveTriangulation, Select3D_SensitiveWire, Select3D_SensitiveBox, Select3D_SensitiveCurve, Select3D_SensitiveFace, Select3D_SensitivePoint, MeshVS_SensitivePolyhedron, Select3D_SensitiveTriangle, MeshVS_SensitiveMesh, MeshVS_SensitiveFace, and MeshVS_SensitiveSegment.

virtual Standard_Boolean Select3D_SensitiveEntity::Matches | ( | const TColgp_Array1OfPnt2d & | Polyline,
|  | const Bnd_Box2d & | aBox,
|  | const Standard_Real | aTol
| ) |  |
| virtual

prevents from hiding virtual methods...

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveGroup, Select3D_SensitiveSegment, Select3D_SensitiveCircle, Select3D_SensitiveTriangulation, Select3D_SensitiveWire, Select3D_SensitiveBox, Select3D_SensitiveCurve, Select3D_SensitiveFace, Select3D_SensitivePoint, MeshVS_SensitivePolyhedron, Select3D_SensitiveTriangle, MeshVS_SensitiveMesh, MeshVS_SensitiveFace, and MeshVS_SensitiveSegment.

virtual Standard_Integer Select3D_SensitiveEntity::MaxBoxes | ( |  | ) | const
| virtual

Returns the max number of sensitive areas returned by this class is 1 by default. Else on must redefine this method.

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveSegment, Select3D_SensitiveGroup, and Select3D_SensitiveWire.

Standard_Boolean Select3D_SensitiveEntity::NeedsConversion | ( |  | ) | const
| virtual

Returns true if this framework needs conversion.

Implements SelectBasics_SensitiveEntity.

virtual void Select3D_SensitiveEntity::Project | ( | const Handle< Select3D_Projector > & | aProjector | ) |
| pure virtual

In classes inheriting this framework, you must redefine this function in order to get a sensitive 2D rectangle from a 3D entity. This rectangle is the sensitive zone which makes the 3D entity selectable.

Implemented in Select3D_SensitiveCircle, Select3D_SensitiveGroup, Select3D_SensitiveSegment, Select3D_SensitiveTriangulation, Select3D_SensitiveBox, Select3D_SensitiveWire, MeshVS_SensitiveMesh, MeshVS_SensitivePolyhedron, Select3D_SensitivePoint, Select3D_SensitivePoly, MeshVS_SensitiveFace, and MeshVS_SensitiveSegment.

virtual void Select3D_SensitiveEntity::ResetLocation | ( |  | ) |
| virtual

sets the location to Identity

Reimplemented in Select3D_SensitiveTriangulation, Select3D_SensitiveGroup, and Select3D_SensitiveWire.

virtual void Select3D_SensitiveEntity::SetLocation | ( | const TopLoc_Location & | aLoc | ) |
| virtual

Reimplemented in Select3D_SensitiveTriangulation, Select3D_SensitiveGroup, and Select3D_SensitiveWire.

void Select3D_SensitiveEntity::UpdateLocation | ( | const TopLoc_Location & | aLoc | ) |

The documentation for this class was generated from the following file:

- Select3D_SensitiveEntity.hxx